﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DirectDrawFixer
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        RegOP _regOP;

        public MainWindow()
        {
            if (MessageBox.Show("Are you using a 32bit version of Win 7?", "question", MessageBoxButton.YesNo) == MessageBoxResult.No)
            {
                RegOP.wownode = @"\Wow6432Node";
            }
            InitializeComponent();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            string appName;
            UInt32 appID;
            if (RegOP.ReadRecent(out appName, out appID))
            {
                labelRecentID.Content = appID.ToString("X08");
                labelRecentName.Content = appName;
            }
            else
            {
                MessageBox.Show("Fail to access registry!");
            }
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            _regOP = new RegOP();
            lvConfigs.Items.Clear();
            _regOP.GetList().ForEach(x => lvConfigs.Items.Add(x));
        }

        private void Window_Loaded_1(object sender, RoutedEventArgs e)
        {
            Button_Click_1(sender, e);
            Button_Click_2(sender, e);
        }

        private void lvConfigs_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var si = lvConfigs.SelectedItem;
            if (si != null)
            {
                var item = _regOP.GetItem(si.ToString());
                editFlags.Text = item.Flags.ToString("X08");
                editID.Text = item.ID.ToString("X08");
                editName.Text = item.Name;
            }
        }

        private void buttonRemove_Click(object sender, RoutedEventArgs e)
        {
            var si = lvConfigs.SelectedItem;
            if (si != null)
            {
                if (MessageBox.Show("Are you sure you want to delete this key?\n!!!Use this function at your own risk!!!", "Warning", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
                {
                    _regOP.RemoveConfig(si.ToString());
                    _regOP.RefreshList();
                    Button_Click_2(sender, e);
                }
            }
        }

        private void buttonAdd_Click(object sender, RoutedEventArgs e)
        {
            RegOP.ConfigKey ck;
            ck.Name = (string) labelRecentName.Content;
            ck.SubKey = "fix." + (string) labelRecentName.Content;
            ck.Flags = UInt32.Parse(editNewFlags.Text, System.Globalization.NumberStyles.AllowHexSpecifier);
            ck.ID = UInt32.Parse((string)labelRecentID.Content, System.Globalization.NumberStyles.AllowHexSpecifier);
            if (!_regOP.AddConfig(ck))
            {
                MessageBox.Show("Maybe it already exists!", "error");
            }
            else
            {
                _regOP.RefreshList();
                Button_Click_2(sender, e);
            }
        }
    }
}
